-module(token_bucket).

-export([
  is_limit_reached/1,
  is_limit_reached/2
]).

-define(DEFAULT_RPS, 3).

-type user_id() :: pos_integer().
-type max_rps() :: pos_integer() | infinity.

-spec is_limit_reached(user_id()) -> boolean().
is_limit_reached(UserId) ->
  is_limit_reached(UserId, ?DEFAULT_RPS).

-spec is_limit_reached(user_id(), max_rps()) -> boolean().
is_limit_reached(_UserId, _MaxRps) ->
  {error, not_implemented}.
